#include<bits/stdc++.h>
using namespace std;
int main()
{
    int n;
    cin>>n;
    int O, A, B, AB;
    cin>>O>>A>>B>>AB;
    int a[n];
    string c[n];
    int rez[n][4]={{0}};
    for(int i=0; i<n; i++)
    {
        cin>>c[i]>>a[i];
    }
    for(int i=0;i<n;i++)
    {
        if(c[i] == "O")
        {
          if(O >= a[i])
          {
                O=O-a[i];
                rez[i][0]=a[i];
          }
          else
          {
              cout<<"nemoguce"<<endl;
              return 0;
          }
        }
        else if(c[i] == "A")
        {
            if(A >= a[i])
            {
                A=A-a[i];
                rez[i][1] = a[i];
            }
            else
            {
                a[i] = a[i] - A;
                rez[i][1] = A;
                if(a[i] <= O)
                {
                    O = O - a[i];
                    rez[i][0] = a[i];
                }
                else
                {
                    cout<<"nemoguce"<<endl;
                    return 0;
                }
            }
        }
        else if(c[i] == "B")
        {
            if(B >= a[i])
            {
                B=B-a[i];
                rez[i][2] = a[i];
            }
            else
            {
                a[i] = a[i] - B;
                rez[i][2] = B;
                if(O >= a[i])
                {
                    O = O - a[i];
                    rez[i][0] = a[i];
                }
                else
                {
                    cout<<"nemoguce"<<endl;
                    return 0;
                }
            }
        }
        else if(c[i] == "AB")
        {
            if(AB >= a[i])
            {
                AB = AB - a[i];
                rez[i][3] = a[i];
            }
            else
            {
                a[i] = a[i] - AB;
                rez[i][3] = AB;
                if(O >= a[i])
                {
                    O = O - a[i];
                    rez[i][0] = a[i];
                }
                else
                {
                    a[i] = a[i] - O;
                    rez[i][0] = O;
                    if(A >= a[i])
                    {
                        A = A - a[i];
                        rez[i][1] = a[i];
                    }
                    else
                    {
                        a[i] = a[i] - A;
                        rez[i][1] = A;
                        if(B >= a[i])
                        {
                            B = B - a[i];
                            rez[i][2] = a[i];
                        }
                        else
                        {
                            cout<<"nemoguce"<<endl;
                            return 0;
                        }
                    }
                }
            }
        }
    }
    cout<<"moguce"<<endl;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<4; j++)
        {
            cout<<rez[i][j]<<" ";
        }
        cout<<endl;
    }
    return 0;
}